CREATE OR REPLACE FUNCTION USR_FUNC_BLOQUEIO(
   P_TABELA       IN VARCHAR2,
   P_IDOPERACAO   IN VARCHAR2,
   P_ERROR        IN VARCHAR2 DEFAULT 'OK') RETURN VARCHAR2 IS
   PRAGMA AUTONOMOUS_TRANSACTION;
   V_COUNT          INTEGER;
   V_AUX            VARCHAR2(3000);
   V_TABELA         VARCHAR2(30);
   V_IDORIGREGISTRO USR_BLOQUEIO.IDORIGREGISTRO%TYPE;
   V_DTGRAVACAO     USR_BLOQUEIO.DTGRAVACAO%TYPE;
   V_HRGRAVACAO     USR_BLOQUEIO.HRGRAVACAO%TYPE;
   V_DTULTATU       DATE;
   V_DESCRICAO      USR_LOGINTTEKNISA.DSLOGINTEGRACAO%TYPE;
   V_ERROR          VARCHAR2(100);
BEGIN
   V_COUNT    := 0;
   V_DTULTATU := SYSDATE;
   V_ERROR    := 'No fue posible realizar el bloqueo porque la tabla ya estaba bloqueada por otra aplicacin.';
   IF P_IDOPERACAO = 'B' THEN
      V_IDORIGREGISTRO := 'T';
      V_DTGRAVACAO     := TO_DATE(SYSDATE);
      V_HRGRAVACAO     := TO_CHAR(SYSDATE, 'HH24MI');
      V_COUNT          := 0;
      V_DESCRICAO      := 'Inicio de la Operacin - Bloqueo de la tabla';
      SELECT COUNT(1)
        INTO V_COUNT
        FROM USR_BLOQUEIO
       WHERE INSTR(P_TABELA, NMTABELA) > 0
         AND IDORIGREGISTRO IS NOT NULL
         AND DTGRAVACAO IS NOT NULL
         AND HRGRAVACAO IS NOT NULL;
   END IF;
   IF P_IDOPERACAO = 'D' THEN
      V_IDORIGREGISTRO := NULL;
      V_DTGRAVACAO     := NULL;
      V_HRGRAVACAO     := NULL;
      V_DESCRICAO      := 'Fin de la Operacin - Desbloqueo de la tabla';
   END IF;
   IF V_COUNT > 0 THEN
      V_AUX := P_TABELA;
      WHILE (INSTR(V_AUX, '%') > 0) LOOP
         V_TABELA := SUBSTR(V_AUX, 1, INSTR(V_AUX, '%') - 1);
         V_AUX    := SUBSTR(V_AUX, INSTR(V_AUX, '%')+1, LENGTH(V_AUX));
         INSERT INTO USR_LOGINTTEKNISA (NMTABELA, IDORIGREGISTRO, DSLOGINTEGRACAO, DTOPERACAO, DSRESULT)
         VALUES(V_TABELA, 'T', V_DESCRICAO, V_DTULTATU, V_ERROR);
         COMMIT;
      END LOOP;
      IF LENGTH(V_AUX) > 0 THEN
         INSERT INTO USR_LOGINTTEKNISA (NMTABELA, IDORIGREGISTRO, DSLOGINTEGRACAO, DTOPERACAO, DSRESULT)
         VALUES(V_AUX, 'T', V_DESCRICAO, V_DTULTATU, V_ERROR);
         COMMIT;
      END IF;
      RETURN('N');
   ELSE
      V_AUX := P_TABELA;
      WHILE (INSTR(V_AUX, '%') > 0) LOOP
        V_TABELA := SUBSTR(V_AUX, 1, INSTR(V_AUX, '%') - 1);
        V_AUX    := SUBSTR(V_AUX, INSTR(V_AUX, '%')+1, LENGTH(V_AUX));
        UPDATE USR_BLOQUEIO
          SET IDORIGREGISTRO = V_IDORIGREGISTRO, DTGRAVACAO = V_DTGRAVACAO, HRGRAVACAO = V_HRGRAVACAO
        WHERE NMTABELA = V_TABELA;
        COMMIT;
        INSERT INTO USR_LOGINTTEKNISA (NMTABELA, IDORIGREGISTRO, DSLOGINTEGRACAO, DTOPERACAO, DSRESULT)
        VALUES(V_TABELA, 'T', V_DESCRICAO, V_DTULTATU, P_ERROR);
        COMMIT;
      END LOOP;
      IF LENGTH(V_AUX) > 0 THEN
        UPDATE USR_BLOQUEIO
           SET IDORIGREGISTRO = V_IDORIGREGISTRO, DTGRAVACAO = V_DTGRAVACAO, HRGRAVACAO = V_HRGRAVACAO
         WHERE NMTABELA = V_AUX;
        COMMIT;
        INSERT INTO USR_LOGINTTEKNISA (NMTABELA, IDORIGREGISTRO, DSLOGINTEGRACAO, DTOPERACAO, DSRESULT)
        VALUES(V_AUX, 'T', V_DESCRICAO, V_DTULTATU, P_ERROR);
        COMMIT;
      END IF;
      RETURN('S');
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_FUNC_BLOQUEIO','5.09.xxx'); END;
/        