const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geralPage = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const autorizacaoParaObterXmlPage = require('../../../page-objects/parametrizacao/documentos fiscais/autorizacaoParaObterXml.po.js');
const j = require('../../../json/leitorJson.po');
const autorizacaoParaObterXmlGridId = '495202327411421901674';


describe('Tela Autorização Para Obter XML', () => {
    beforeAll(() => {
        loginPage.login(j.getValor('login'), j.getValor('senha'));
        autorizacaoParaObterXmlPage.abrir();
        protractorHelper.waitForElementVisibility(element(by.id(`grid-${autorizacaoParaObterXmlGridId}`)),
            5000);
    });

    afterAll(() => {
        geralPage.sair();
    });

    fit('Acessar tela Autorização Para Obter XML', () => {
        expect(z.component.header.getTitle()).toBe('Autorização Para Obter XML');
    });

    fit('Adicionar Pessoa Física', () => {
        autorizacaoParaObterXmlPage.adicionarPessoaFisica(j.getValor('nrinsjurautoxml01'), j.getValor('dsobsautoxml01'));
        geralPage.filterIt(j.getValor('dsobsautoxml01'));
        expect(geralPage.gridHasText('495202327411421901674', j.getValor('dsobsautoxml01'), 1)).toBe(j.getValor('dsobsautoxml01'));
    });

    fit('Adicionar Pessoa Jurídica', () => {
        autorizacaoParaObterXmlPage.adicionarPessoaJuridica(j.getValor('nrinsjurautoxml02'), j.getValor('dsobsautoxml02'));
        geralPage.filterIt(j.getValor('dsobsautoxml02'));
        expect(geralPage.gridHasText('495202327411421901674', j.getValor('dsobsautoxml02'), 1)).toBe(j.getValor('dsobsautoxml02'));
    });

    it('Editar Pessoa Jurídica', () => {
        autorizacaoParaObterXmlPage.editarPessoaJuridica(j.getValor('dsobsautoxml04'));
        geralPage.filterIt(j.getValor('dsobsautoxml04'));
        expect(geralPage.gridHasText('495202327411421901674', j.getValor('dsobsautoxml04'), 1)).toBe(j.getValor('dsobsautoxml04'));
    });

    it('Excluir Pessoa Física', () => {
        autorizacaoParaObterXmlPage.excluirPessoaFisica(j.getValor('dsobsautoxml01'));
        geralPage.filterIt(j.getValor('dsobsautoxml01'));
        expect(geralPage.gridHasText('495202327411421901674', j.getValor('dsobsautoxml01'), 1)).toBeUndefined(j.getValor('dsobsautoxml01'));
    });

    fit('Adicionar Pessoa física por IE', () => {
        autorizacaoParaObterXmlPage.adicionarPessoaFisicaPorIe(j.getValor('nrinsjurautoxml03'), j.getValor('dsobsautoxml03'));
        geralPage.filterIt(j.getValor('dsobsautoxml03'));
        expect(geralPage.gridHasText('4952023273444274517688', j.getValor('dsobsautoxml03'), 1)).toBe(j.getValor('dsobsautoxml03'));
    });

    fit('Adicionar Pessoa jurídica 1 por IE ', () => {
        autorizacaoParaObterXmlPage.adicionarPessoaJuridicaPorIe(j.getValor('nrinsjurautoxml02'), j.getValor('dsobsautoxml04'));
        geralPage.filterIt(j.getValor('dsobsautoxml04'));
        expect(geralPage.gridHasText('4952023273444274517688', j.getValor('dsobsautoxml04'), 1)).toBe(j.getValor('dsobsautoxml04'));
    });

    fit('Adicionar Pessoa jurídica 2 por IE', () => {
        autorizacaoParaObterXmlPage.adicionarPessoaJuridicaPorIe(j.getValor('nrinsjurautoxml04'), j.getValor('dsobsautoxml05'));
        geralPage.filterIt(j.getValor('dsobsautoxml05'));
        expect(geralPage.gridHasText('4952023273444274517688', j.getValor('dsobsautoxml05'), 1)).toBe(j.getValor('dsobsautoxml05'));
    });

    fit('Editar Pessoa Fisica por IE', () => {
        autorizacaoParaObterXmlPage.editarPessoaFisicaPorIE();
        geralPage.filterIt(j.getValor('dsobsautoxml01'));
        expect(geralPage.gridHasText('4952023273444274517688', j.getValor('dsobsautoxml01'), 1)).toBe(j.getValor('dsobsautoxml01'));
    });

    it('Excluir Pessoa Física por IE', () => {
        autorizacaoParaObterXmlPage.excluirPessoaFisicaPorIe(j.getValor('dsobsautoxml03'));
        geralPage.filterIt(j.getValor('dsobsautoxml03'));
        expect(geralPage.gridHasText('4952023273444274517688', j.getValor('dsobsautoxml03'), 1)).toBeUndefined(j.getValor('dsobsautoxml03'));
    });

    fit('Replicação Para Obter XML', () => {
        autorizacaoParaObterXmlPage.replicacaoParaObterXml();
        geralPage.filterIt(j.getValor('dsobsautoxml04'));
        expect(geralPage.gridHasText('4952023273444274517688', j.getValor('dsobsautoxml04'), 1)).toEqual('Madero NF-e Fiscal Processos S.A.');
        element(by.className('clear-button zh-icon zh-icon-close-x')).click();
        browser.sleep(2000);
        const commentField = element(by.className('mousetrap zh-input-search-floating'));
        console.log(commentField);
        commentField.clear();
        commentField.sendKeys('Dunga serviços Fiscais e Eletrônicos Ltda');
        expect(geralPage.gridHasText('4952023273444274517688', j.getValor('dsobsautoxml04'), 1)).toEqual('Madero NF-e Fiscal Processos S.A.');
        browser.sleep(2000);
        expect(geralPage.gridHasText('4952023273444274517688', j.getValor('dsobsautoxml05'), 1)).toEqual('Dunga serviços Fiscais e Eletrônicos Ltda');
    });
});
